import { Uint8ArrayList } from 'uint8arraylist';
import type { LengthDecoderFunction } from './index.js';
import type { Reader } from 'it-reader';
import type { Source } from 'it-stream-types';
export interface ReadState {
    dataLength: number;
}
export interface DecoderOptions {
    lengthDecoder?: LengthDecoderFunction;
    onData?: (data: Uint8ArrayList) => void;
    onLength?: (length: number) => void;
    maxLengthLength?: number;
    maxDataLength?: number;
}
export interface ReadResult {
    mode: string;
    chunk?: Uint8ArrayList;
    buffer: Uint8ArrayList;
    state?: ReadState;
    data?: Uint8ArrayList;
}
export declare const MAX_LENGTH_LENGTH = 8;
export declare const MAX_DATA_LENGTH: number;
export declare function decode(source: Iterable<Uint8ArrayList | Uint8Array>, options?: DecoderOptions): Generator<Uint8ArrayList, void, unknown>;
export declare function decode(source: Source<Uint8ArrayList | Uint8Array>, options?: DecoderOptions): AsyncGenerator<Uint8ArrayList, void, unknown>;
export declare namespace decode {
    var fromReader: (reader: Reader, options?: DecoderOptions | undefined) => AsyncGenerator<Uint8ArrayList, void, unknown>;
}
//# sourceMappingURL=decode.d.ts.map